import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.*;
import javax.swing.GroupLayout.Alignment;
import javax.swing.filechooser.FileNameExtensionFilter;

public class TSVconverter extends JFrame implements ActionListener {
	private static final long serialVersionUID = 1L;
	
	JTextArea inTVS, outBMSdif;
	JTextArea header, transrateRule, footer;
	JButton bRunTransrate;
	JButton bSaveSetting, bLoadSetting, bApplySetting;
	
	JFileChooser rulefileChooser;

	public static void main(String[] args){
		TSVconverter frame = new TSVconverter();
		frame.setVisible(true);
	}
	
	TSVconverter(){
		setBounds(10,10,600,500);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setTitle("TSVconverter");
		
		/*
		//CƐݒp̃^u
		JTabbedPane tab = new JTabbedPane();
		getContentPane().add(tab, BorderLayout.CENTER);
		*/
		//plɂĂPʂɂ悤ɕύX
		JPanel pAll = new JPanel();
		pAll.setLayout(new GridLayout(1,2));
		getContentPane().add(pAll, BorderLayout.CENTER);
		
		//C
		////////////
		
		//Cʗppl
		JPanel pmain = new JPanel();
		pmain.setLayout(new BorderLayout());
		//tab.addTab("ϊ", pmain);
		pAll.add(pmain);
		
		//̓{bNX
		inTVS = new JTextArea();
		JScrollPane inScroll = new JScrollPane(inTVS, 
		JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, 
		JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		//o̓{bNX
		outBMSdif = new JTextArea();
		//outBMSdif.setEditable(false);
	    outBMSdif.setBackground(Color.LIGHT_GRAY);
		JScrollPane outScroll = new JScrollPane(outBMSdif, 
			      JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, 
			      JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		
		//o͗ppl
		JPanel pio = new JPanel();
		pio.setLayout(new GridLayout(2,1));
		pio.add(inScroll);
		pio.add(outScroll);
		pmain.add(pio, BorderLayout.CENTER);
		
		//ϊ{^
		bRunTransrate = new JButton("ϊ");
		bRunTransrate.addActionListener(this);
		pmain.add(bRunTransrate, BorderLayout.PAGE_END);
		
		//ݒ
		//////////

		//ݒppl
		JPanel psetting = new JPanel();
		psetting.setLayout(new BorderLayout());
		//tab.addTab("ݒ", psetting);
		pAll.add(psetting);
		
		//͗ppl
		JPanel psettingText = new JPanel();
		psetting.add(psettingText, BorderLayout.CENTER);
		
		GroupLayout groupLayout = new GroupLayout(psettingText);
		psettingText.setLayout(groupLayout);
		groupLayout.setAutoCreateGaps(true);
		groupLayout.setAutoCreateContainerGaps(true);
		
		//R|[lg𐶐
		JLabel labelHeader = new JLabel("wb_");
		JLabel labelTransrateRule = new JLabel("ϊ[");
		JLabel labelFooter = new JLabel("tb^");
		//eeLXgGA
		header = new JTextArea();
		JScrollPane headerScroll = new JScrollPane(header, 
		JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, 
		JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		transrateRule = new JTextArea();
		JScrollPane transrateRuleScroll = new JScrollPane(transrateRule, 
		JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, 
		JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		footer = new JTextArea();
		JScrollPane footerScroll = new JScrollPane(footer,
		JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, 
		JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		
		//xƓ̓{bNX\
		
		//񂲂
		GroupLayout.SequentialGroup hGroup = groupLayout.createSequentialGroup();
		hGroup.addGroup(groupLayout.createParallelGroup()
			.addComponent(labelHeader).addComponent(labelTransrateRule).addComponent(labelFooter));
		hGroup.addGroup(groupLayout.createParallelGroup()
			.addComponent(headerScroll).addComponent(transrateRuleScroll).addComponent(footerScroll));
        groupLayout.setHorizontalGroup(hGroup);
		
        //s
		GroupLayout.SequentialGroup vGroup = groupLayout.createSequentialGroup();
		vGroup.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
			.addComponent(labelHeader)).addComponent(headerScroll);
		vGroup.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
			.addComponent(labelTransrateRule)).addComponent(transrateRuleScroll);
		vGroup.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
			.addComponent(labelFooter)).addComponent(footerScroll);
		groupLayout.setVerticalGroup(vGroup);
		
		
		//ppl
		JPanel psettingButtons = new JPanel();
		psetting.add(psettingButtons, BorderLayout.SOUTH);
		
		psettingButtons.setLayout(new GridLayout(1,3));
		
		//{^	KpɕϊɎIɓKp悤ɕύX
		/*
		bApplySetting = new JButton("Kp");
		bApplySetting.addActionListener(this);
		psettingButtons.add(bApplySetting);
		*/
		
		bSaveSetting = new JButton("ۑ");
		bSaveSetting.addActionListener(this);
		psettingButtons.add(bSaveSetting);
		
		bLoadSetting = new JButton("ǂݍ");
		bLoadSetting.addActionListener(this);
		psettingButtons.add(bLoadSetting);
		
		
		//ݒۑEǂݍݗpt@C_CAOݒ
		rulefileChooser = new JFileChooser();
		File curDir = new File(System.getProperty("user.dir"));
		rulefileChooser.setCurrentDirectory(curDir);
		rulefileChooser.setFileFilter(new FileNameExtensionFilter("ϊ[t@C *."+ ruleExtension , ruleExtension));
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		Object temp = e.getSource();
		if(temp == bRunTransrate){
			transform();
		}
		if(temp == bApplySetting){
			applySetting();
		}
		if(temp == bSaveSetting){
			saveSetting();
		}
		if(temp == bLoadSetting){
			loadSetting();
		}
	}
	
	//ϊs
	private void transform(){
		/*
		toBMSdifficult transer = new toBMSdifficult();
		String transed = transer.trans(inTVS.getText());
		outBMSdif.setText(transed);
		*/
		Converter converter = new Converter();
		converter.setSetting(header.getText(),
				transrateRule.getText(),
				footer.getText());
		String converted = converter.convert(inTVS.getText());
		outBMSdif.setText(converted);
		
	}
	
	//ݒKp
	private void applySetting(){
		System.out.println("apply");
	}
	
	//ݒۑ
	private static final String ruleExtension = "rule";
	private void saveSetting(){
		System.out.println("save");

		//ۑt@CpX擾
		int selected = rulefileChooser.showSaveDialog(this);
		
		//LZ܂̓G[Ȃǂ̏ꍇ͕ۑsȂ
		if(selected != JFileChooser.APPROVE_OPTION){
			return;
		}
		//gq⊮
		String ext = getExtension(rulefileChooser.getSelectedFile());
		File saveFile;
		if(ext == null){
			saveFile = new File(rulefileChooser.getSelectedFile().getPath() + "." + ruleExtension);
		}else{
			saveFile = rulefileChooser.getSelectedFile();
		}
		
		//G[`FbN
		
		if(saveFile.exists()){
			int yesno = JOptionPane.showConfirmDialog(this, "㏑܂낵łH",
					"㏑mF",
					JOptionPane.OK_CANCEL_OPTION);
			
			if(yesno == JOptionPane.CANCEL_OPTION){
				return;
			}
			
			if(!saveFile.canWrite()){
				JOptionPane.showMessageDialog(this, "݂ł܂łB");
				return;
			}
		}
		
		
		
		//ۑs
		String savePath = saveFile.getPath();
		FileWriter writer = null;
		try{
			writer = new FileWriter(savePath);
			
			//f[^ʏ
			int headerLength = header.getText().length();
			int ruleLength = transrateRule.getText().length();
			int footerLength= footer.getText().length();
			String saveHeader = headerLength + "," + ruleLength + "," + footerLength;
			writer.write(saveHeader);
			
			//؂菑
			writer.write("\r\n");
			
			//g
			writer.write(header.getText());
			writer.write(transrateRule.getText());
			writer.write(footer.getText());
			
		}catch(IOException e){
			JOptionPane.showMessageDialog(this, "݂Ɏs܂B");
		}finally{
			//ݓrɃG[ꍇcloseȂ댯̂finally߂close
			try{
				if(writer != null){
					writer.close();
					writer = null;
				}
			}catch(IOException e){
				
			}
		}
		
	}

	//ݒǂݍ
	private void loadSetting(){
		System.out.println("load");

		//ǂݍ݃t@CpX擾
		int selected = rulefileChooser.showOpenDialog(this);
		
		//LZ܂̓G[Ȃǂ̏ꍇ͕ۑsȂ
		if(selected != JFileChooser.APPROVE_OPTION){
			return;
		}
		
		File loadFile = rulefileChooser.getSelectedFile();
		
		loadSetting(loadFile);
	}
	
	//t@Cw肵Đݒǂݍ
	private void loadSetting(File loadFile){
		//G[`FbN
		if(!loadFile.canRead()){
			JOptionPane.showMessageDialog(this, "ǂݍ݂ł܂łB");
		}
		
		//ǂݍ񂾓e̕ۑꏊ
		StringBuffer settingDataBuf = new StringBuffer(100);
		
		//t@Cǂݍ
		FileReader reader = null;
		try{
			reader = new FileReader(loadFile);
			
			int ch;
			
			while ((ch = reader.read()) != -1){
				settingDataBuf.append((char)ch);
			}
			
		}catch(FileNotFoundException e){
			JOptionPane.showMessageDialog(this, "t@C܂B");
		}catch(IOException e){
			
		}finally{
			//ǂݍݓrɃG[ꍇcloseȂ댯̂finally߂close
			try{
				if(reader != null){
					reader.close();
					reader = null;
				}
			}catch(IOException e){
				JOptionPane.showMessageDialog(this, "t@C̂Ɏs܂B");
			}
		}
		
		//wb_o
		String settingData = settingDataBuf.toString();
		String[] setting = new String[2];
		String[] lengthStr = new String[3];
		int headerLength, ruleLength, footerLength;
		
		setting = settingData.split("\r\n", 2);
		lengthStr = setting[0].split(",", 3);

		//o
		headerLength = Integer.parseInt(lengthStr[0]);
		ruleLength   = Integer.parseInt(lengthStr[1]);
		footerLength = Integer.parseInt(lengthStr[2]);
		
		
		//f[^𕪊ēǂݏoAݒ肷B
		String tmp;
		
		tmp = setting[1].substring(0, headerLength);
		header.setText(tmp);
		tmp = setting[1].substring(headerLength, headerLength + ruleLength);
		transrateRule.setText(tmp);
		tmp = setting[1].substring(headerLength + ruleLength, headerLength + ruleLength + footerLength);
		footer.setText(tmp);
	}
	

	private String getExtension(File f){
		String ext = null;
		String filename = f.getName();
		int dotIndex = filename.lastIndexOf('.');
		
		if ((dotIndex > 0) && (dotIndex < filename.length() - 1)){
			ext = filename.substring(dotIndex + 1).toLowerCase();
		}
		
		return ext;
	}
}

class Converter{
	/*
	 * 
	 * $0$	0ڂWJ
	 * $1|"a","b"$		1ڂabɒuēWJ
	 * $2 | "\"",  "$$" $	2ڂ"$ɒuēWJ(K\Ń}b`O)
	 */
	private static String UNFOLDING_RULE_NORMAL = "\\s*\\d+\\s*(\\|\\s*\".*[^\\\\]\"\\s*,\\s*\".*[^\\\\]\")?";
	
	private String header, /*rule,*/ footer;
	
	private String[] terms;
	private int[] tvsIndex;
	private String[] replaceRegx;
	private String[] replaceReplacement;
	
	//BQƂԍ+1܂ŕsB
	int splitNum;

	public void setSetting(String header, String rule, String footer){
		setHeader(header);
		setRule(rule);
		setFooter(footer);
	}
	public void setHeader(String str){
		header = str;
	}
	public void setFooter(String str){
		footer = str;
	}
	
	public void setRule(String str){
		//rule = str;
		
		String[] tempTerms = str.split("\\$");
		
		int termCount = 0;
		String[] tempResult = new String[tempTerms.length];
		for(int i = 0; i < tempResult.length; ++i){
			tempResult[i] = new String();
		}
		//]Ɋmۂ\邪Aɂ͉eȂ
		tvsIndex = new int[tempTerms.length];
		replaceRegx = new String[tempTerms.length];
		replaceReplacement = new String[tempTerms.length];
		
		for(int i = 0; i < tempTerms.length; ++i){
			//̕񂪋̏ꍇ $$ ƏĂ̂$ǉĂ玟̕ƘAB
			if(tempTerms[i].equals("")){
				--termCount;
				tempResult[termCount] = tempResult[termCount].concat("$");
				continue;
			}
			tempResult[termCount] += tempTerms[i];
			
			if(termCount % 2 == 0){
				//P̉͒͂̎_ŊBɈڂB
				++termCount;
				continue;
			}
			
			//WJ镶͒̏ꍇ$̉\̂łl$̃GXP[vsB
			if( tempTerms[i].matches(UNFOLDING_RULE_NORMAL) ){
				//ʏ̏ꍇ
				String[] expr = tempTerms[i].split("\\|", 2);
				String temp;
				
				//ido
				temp = expr[0].replaceAll("\\s", "");
				tvsIndex[termCount] = Integer.parseInt(temp);
				splitNum = Math.max(tvsIndex[termCount]+2, splitNum);
				
				//u擾
				if( expr.length == 1){
					replaceRegx[termCount] = "";
					replaceReplacement[termCount] ="";
				}else{
					expr = expr[1].split("\"",-1);	//"Pʂŋ؂
					/*
					 * [0] 
					 * [1] f[^
					 * [2] "^\s*,\s*$"iԂ̋؂ɂȂBɂȂΎf[^\"ƂɂȂ̂ŘAKvj
					 * [3] f[^
					 * [4] 
					 */
					
					//O
					temp = expr[1];
					int j;
					for( j = 2; j < expr.length ; ++j){	//[v̏IƑȂƂ܂
						if(expr[j].matches("^\\s*,\\s*$")){
							break;
						}
						temp = temp.concat("\""+expr[j]);
					}
					replaceRegx[termCount] = temp;
					
					//㔼
					temp = expr[++j];
	
					for( ++j; j < expr.length-1 ; ++j){
						/*
						if(expr[j].matches("^\\s*$")){
						
							break;
						}
						*/
						temp = temp.concat("\""+expr[j]);
					}
					replaceReplacement[termCount] = temp;
				}
			}else{
				
			}
			
			++termCount;
		}
		terms = new String[termCount];
		System.arraycopy(tempResult, 0, terms, 0, termCount);
	}
	
	
	
	public String convert(String tvs){
		StringBuffer result = new StringBuffer(header);
		
		String[] datas = tvs.split("\\n");
		
		for(int i=0; i < datas.length; ++i){
			String[] items = datas[i].split("\t",splitNum);		//`10
			for(int j = 0; j < terms.length; ++j){
				if(j%2 == 0){
					//ʏ핶
					result.append(terms[j]);
				}else{
					//WJ
					String temp;
					if(replaceRegx[j].equals("")){
						temp = items[tvsIndex[j]];
					}else{
						temp = items[tvsIndex[j]].replaceAll(replaceRegx[j], replaceReplacement[j]);
					}
					result.append(temp);
				}
			}
		}
		
		result.append(footer);
		return result.substring(0);
	}
	
	
}
